import { Component, OnInit, Inject } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material/dialog';
import { ActivatedRoute, Params } from '@angular/router';
import { BaseComponent } from '@common/base/base.component';
import { takeUntil } from 'rxjs/operators';
import { Oauth2DialogService } from './service/oauth2-dialog.service';

@Component({
  selector: 'app-oauth2-dialog',
  templateUrl: './oauth2-dialog.component.html',
  styleUrls: ['./oauth2-dialog.component.scss']
})
export class Oauth2DialogComponent extends BaseComponent implements OnInit{

	constructor(
		private route: ActivatedRoute,
		private oauth2dialogService: Oauth2DialogService
	) {
		super();
	}


	ngOnInit(): void {
		this.route.queryParams.pipe(takeUntil(this._destroyed))
		.subscribe((params: Params) => {
			const url = params['url'];
			if (!params['code'] && (!params['oauth_token'] && !params['oauth_verifier'])) { this.loadUrl(url) } else { this.sendCode(params); }
		});
	}

	private loadUrl(url: string ) {
		window.location.href = url;
	}

	private sendCode(params: Params) {
		const oauthObject = {
			oauthCode: params['code'] ? params['code'] : undefined,
			oauthState: params['state'] ? params['state'] : undefined,
		  	oauthToken: params['oauth_token'] ? params['oath_token'] : undefined,
		 	oauthVerifier: params['oauth_verifier'] ? params['oauth_verifier'] : undefined
		};
		localStorage.setItem('arglogRes', JSON.stringify({response: { date: new Date(), data: oauthObject }}));
		window.close();
	}

}
